require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Intent"
import "android.content.Context"

local Symbol={}
local path=this.getLuaExtDir("Plugins").."/Mi Favoris/data"

---读取符号文件函数
local function readSymbol(t,path)
	local file,eor=io.open(path,"r")
	if eor~=nil then
		file,eor=io.open(path,"w")
	end
	
	local s
	for line in io.lines(path) do
		s=string.gsub(line,'\\n','\n')
		s= s=="\\\\" and "\\" or s
		table.insert(t,s)
	end
	file:close()
end

---写入符号函数
local function writeSymbol(t,path)
	file=io.open(path,'w')
	for _,v in ipairs(t) do
		v= v=="\\" and "\\\\" or v
		file:write(string.gsub(v,'\n','\\n')..'\n')
	end
	file:close()
end

---移动函数
local function moveItem(t,k,itemKey)
	local s=t[k+1]
	if itemKey==0 and k>5 then
		table.insert(t,k-5,s)
		table.remove(t,k+2)
		elseif itemKey==1 and #t-k>=7 then
		table.insert(t,k+8,s)
		table.remove(t,k+1)
		elseif itemKey==2 and k>0 then
		t[k],t[k+1]=t[k+1],t[k]
		elseif itemKey==3 and k+1<#t then
		t[k+1],t[k+2]=t[k+2],t[k+1]
		elseif itemKey==4 then
		table.remove(t,k+1)
	end
end

---编辑框界面
local edit=loadlayout({
	EditText;
	hint="Mettez un symbole ou une phrase, qui accepte plus d'une ligne"
})
local et=LuaDialog()
et.setTitle("CRÉER")
et.setView(edit)
et.setButton("ajouter",function()
	if edit.text~='' then
		table.insert(Symbol,edit.text)
		edit.text=''
		writeSymbol(Symbol,path)
	end
	--重新载入符号表
	grid.adapter=SingleLineAdapter(service,String(Symbol))
	dlg.show()
end)

---说明界面
local readme=LuaDialog(service)
readme.setTitle("Aide")
readme.setMessage("C'est un favori dans lequel nous pouvons mettre des symboles, ou des phrases. \nVersion：：V1.0 \nDéveloppeur：：coolsnowbye\n")
readme.setButton("fermer",function()
	dlg.show()
end)

---长按菜单
local menuItem=
{
	"Glisser l'élément vers le haut",
	"Glisser l'élément vers le bas",
	"Glisser l'élément vers la gauche",
	"Glisser l'élément vers la droite",
	"Supprimer",
}
local menuDlg=LuaDialog(service)
--menuDlg.setTitle("菜单")
menuDlg.setItems(menuItem)

---主界面
layout={
	GridView,
	id="grid",
	numColumns=6,
	layout_width="fill",
	layout_height="fill"
}

dlg=LuaDialog(service)
dlg.View=loadlayout(layout)
readSymbol(Symbol,path)
grid.adapter=SingleLineAdapter(service,String(Symbol))
dlg.setButton("fermer")
dlg.setButton2("CRÉER",function(v)
	task(50,function()
		et.show()
	end)
end)
dlg.setButton3("Aide",function(v)
	readme.show()
end)

dlg.show()
grid.onItemClick=function(l,v)
	dlg.dismiss()
	service.pasteText(node,v.text)
	service.speak(v.text)
	return true
end

grid.onItemLongClick=function(l,v,p,i)
	dlg.dismiss()
	vibrator = this.getSystemService(Context.VIBRATOR_SERVICE)
	vibrator.vibrate( long{50,30} ,-1)
	menuDlg.show()
	menuDlg.onItemClick=function(_,_,itemKey)
		menuDlg.dismiss()
		moveItem(Symbol,i,itemKey)
		writeSymbol(Symbol,path)
		--重新载入符号表
		grid.adapter=SingleLineAdapter(service,String(Symbol))
		dlg.show()
	end

end